window.TeslaCloud = window.TeslaCloud || {};

((window, document) =>
{
    'use strict';

    TeslaCloud.HeleketStatus = XF.Element.newHandler({
        options: {
            url: '',
            returnUrl: '',
            updateInterval: 30
        },

        statusPhrase: null,
        statusTime: null,
        statusIcon: null,
        expiredBlock: null,

        updateTimer: null,

        init()
        {
            const target = this.target;

            this.statusPhrase = target.querySelector('#statusPhrase');
            this.statusTime = target.querySelector('#statusTime');
            this.statusIcon = target.querySelector('#statusIcon');
            this.expiredBlock = target.querySelector('#messageExpired');

            this.updateTimer = setInterval(this.updateStatus.bind(this), this.options.updateInterval * 1000);

            let overlay = target.closest('.overlay-container');
            if (overlay && overlay.length)
            {
                overlay.data('overlay')
                       .on('overlay:hidden', () => clearInterval(this.updateTimer));
            }
        },

        updateStatus()
        {
            XF.ajax(
                'get',
                this.options.url,
                {},
                data =>
                {
                    if (data.hasOwnProperty('payment'))
                    {
                        let payment = data.payment;

                        this.statusPhrase.innerText = payment.payment_status_phrase;
                        this.statusTime.innerHTML = payment.expired_at_phrase;

                        if (payment.hasOwnProperty('is_paid') && payment.is_paid === true)
                        {
                            if (this.options.returnUrl !== '')
                            {
                                window.location.replace(this.options.returnUrl);
                            }

                            clearInterval(this.updateTimer);

                            return;
                        }

                        if (payment.hasOwnProperty('is_final') && payment.is_final === true)
                        {
                            XF.Animate.fadeIn(this.expiredBlock);
                            XF.Animate.fadeOut(this.statusIcon);

                            clearInterval(this.updateTimer);
                        }
                    }
                }
            );
        }
    });

    XF.Element.register('tc-pg-heleket-status', 'TeslaCloud.HeleketStatus');
})(window, document);
